"""EmbutidosRaul URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/1.11/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  url(r'^$', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  url(r'^$', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.conf.urls import url, include
    2. Add a URL to urlpatterns:  url(r'^blog/', include('blog.urls'))
"""
from django.conf.urls import url
from django.contrib import admin
from django.conf import settings
from SitioEncuesta.views import probando,DeleteEncuesta,CreateEncuestaView,UpdateEncuestaView,CreateRespuestaView, ListRespuestaView,DetailRespuesta,DeleteRespuesta,UpdateRespuestaView, DetailEncuesta,ListEncuestaView, ListPreguntaView, DetailPregunta, CreatePreguntaView, UpdatePreguntaView, DeletePregunta
from SitioEncuesta import views
from django.contrib.auth.views import login,logout_then_login

from SitioEncuesta.views import HomeView, get_data

app_name = 'encuestas'

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^prueba/$',probando, name='prueba'),
    url(r'^$',login, {'template_name':'login.html'}, name='login'),
    url(r'^accounts/login/$',login, {'template_name':'login.html'}, name='login'),
    url(r'^logout/', logout_then_login, name='logout'),

    #URL DE PREGUNTA
    url(r'^ListarPregunta',ListPreguntaView.as_view(), name='pregunta_list'),
    url(r'^(?P<pk>\d+)',DetailPregunta.as_view(), name='pregunta_detail'),
    url(r'^deletePregunta-(?P<pk>\d+)',DeletePregunta.as_view(), name='pregunta_delete'),
    url(r'^newPregunta$',CreatePreguntaView.as_view(), name='pregunta_new',),
    url(r'^updatePregunta-(?P<pk>\d+)$',UpdatePreguntaView.as_view(), name='pregunta_update',),

    #URL DE ENCUESTAS
    url(r'^listEncuesta', ListEncuestaView.as_view(), name='encuesta_list',),
    url(r'^detalleEncuesta-(?P<pk>\d+)', DetailEncuesta.as_view(), name='encuesta_detail',),
    url(r'^deleteEncuesta-(?P<pk>\d+)',DeleteEncuesta.as_view(), name='encuesta_delete'),
    url(r'^newEncuesta$',CreateEncuestaView.as_view(), name='encuesta_new',),
    url(r'^updateEncuesta-(?P<pk>\d+)$',UpdateEncuestaView.as_view(), name='encuesta_update',),
    url(r'^Muestreo-(?P<encuesta_id>[0-9]+)$',views.muestreo, name='Muestreo',), 
    url(r'^RMuestreo-(?P<encuesta_id>[0-9]+)$',views.Rmuestreo, name='Rmuestreo',), 

#URL DE RESPUESTAS
    url(r'^ListarRespuesta',ListRespuestaView.as_view(), name='respuesta_list'),
    url(r'^detalleRespuesta-(?P<pk>\d+)', DetailRespuesta.as_view(), name='respuesta_detail',),
    url(r'^deleteRespuesta-(?P<pk>\d+)',DeleteRespuesta.as_view(), name='respuesta_delete'),
    url(r'^UpdateRespuestaView-(?P<pk>\d+)$',UpdateRespuestaView.as_view(), name='respuesta_update',),
    url(r'^newRespuesta$',CreateRespuestaView.as_view(), name='respuesta_new',),

    #URL DE ENCUESTA
    url(r'^listEncuesta', ListEncuestaView.as_view(), name='encuesta_list',),
    url(r'^detalleEncuesta-(?P<pk>\d+)', DetailEncuesta.as_view(), name='encuesta_detail',),

###################### CAMBIOS
    #url(r'^prueba2', view.probando, name='prueba2'),
    url(r'^encuesta/(?P<encuesta_id>[0-9]+)/responder/$', views.responder, name='responder'),
    url(r'^encuesta/(?P<encuesta_id>[0-9]+)/resultados/$', views.resultados, name='resultados'),
    url(r'^encuesta/(?P<encuesta_id>[0-9]+)/votar/$', views.votar, name='votar'),
    url(r'^Compartir/(?P<encuesta_id>[0-9]+)/$', views.compartir, name='compartir'),
    url(r'^fin/$', views.fin, name='fin'),
    url(r'^encuesta/(?P<pregunta_id>[0-9]+)/grafica/$', views.grafica, name='grafica'),
#####################   PRUEBA
    url(r'^prueba2/$', HomeView.as_view(), name='home'),
    #url(r'^api/chart/data/$', ChartData.as_view()),
    url(r'^api/data/(?P<pregunta_id>[0-9]+)/$', get_data, name='api-data'),
    ]
