from django.contrib import admin
from SitioEncuesta.models import Usuario, Encuesta, Pregunta, Respuesta

# Register your models here.
class EncuestaAdmin(admin.ModelAdmin):
    list_display = ('id_encuesta', 'titulo', 'fecha_creacion', 'estado', 'cant_participante', 'contPart')
    search_fields = ('id_encuesta', 'titulo', 'fecha_creacion', 'estado', 'cant_participante', 'contPart')

class PreguntaAdmin(admin.ModelAdmin):
    list_display=('id_pregunta', 'id_encuesta', 'descripcion')
    search_fields=('id_pregunta', 'id_encuesta', 'descripcion')

class RespuestaAdmin(admin.ModelAdmin):
    list_display=('id_respuesta','id_pregunta', 'contenido', 'mejor_respuesta', 'votes')
    search_fields=('id_respuesta','id_pregunta', 'contenido', 'mejor_respuesta', 'votes')

class UsuarioAdmin(admin.ModelAdmin):
    list_display=('id_usuario','id_encuesta','ip_usuario')
    search_fields=('id_usuario','id_encuesta','ip_usuario')

admin.site.register(Usuario,UsuarioAdmin)
admin.site.register(Pregunta,PreguntaAdmin)
admin.site.register(Respuesta,RespuestaAdmin)
admin.site.register(Encuesta, EncuestaAdmin)
