
from django import forms
from django.core.exceptions import ValidationError
from SitioEncuesta.models import Pregunta,Respuesta,Encuesta
import re

class PreguntaForm(forms.ModelForm):

    #id_encuesta = forms.ChoiceField(required=True , label="id_encuesta")
    descripcion = forms.CharField(max_length=100,required=True,label="Descripcion")

    class Meta:
        model = Pregunta
        fields = ['id_encuesta','descripcion']

    #def clean_id_encuesta(self):
    #    id_encuesta=self.cleaned_data('id_encuesta')
    #    return id_encuesta

    def clean_descripcion(self):
        descripcion = self.cleaned_data.get('descripcion')
        return descripcion

class RespuestaForm(forms.ModelForm):

    contenido = forms.CharField(max_length=100,required=True,label="Contenido")
    votes = forms.IntegerField(required=True,label="Votos")

    class Meta:
        model = Respuesta
        fields = ['id_pregunta','contenido','votes']

    def clean_contenido(self):
        contenido = self.cleaned_data.get('contenido')
        if(re.match("[a-zA-Z]",contenido)==None):
            raise forms.ValidationError("Debe iniciar con un caracter")
            # "\w*" verifica que todos los caracteres sean alfanumericos # \w es lo mismo que [a-z0-9-A-Z]
        elif (re.match("\w*",contenido)) ==None:
            raise forms.ValidationError("Deben de ser caracters alfanumerico")
        return contenido

    def clean_votes(self):
        votes=self.cleaned_data.get('votes')
        if votes>0:
            raise forms.ValidationError("Debe asignar un valor de cero")
        return votes

class EncuestaForm(forms.ModelForm):

    titulo=forms.CharField(max_length=50, required=True, label="Titulo")
    cant_participante = forms.IntegerField(required=True, label="Cantidad Participantes")
    fecha_creacion=forms.DateField(widget=forms.DateInput(attrs={'class':'input-group date', 'data-provide':'datepicker','data-date-format':'dd/mm/yyyy'}), label="Fecha creacion")
    contPart = forms.IntegerField(required=True, label="Cantidad participantes(han respondido)")


    class Meta:
        model = Encuesta
        fields = ['titulo','cant_participante','fecha_creacion','contPart']


    def clean_titulo(self):
                titulo = self.cleaned_data.get('titulo')
                if(re.match("[a-zA-Z]",titulo)==None):
                    raise forms.ValidationError("Debe iniciar con un caracter")
                    # "\w*" verifica que todos los caracteres sean alfanumericos # \w es lo mismo que [a-z0-9-A-Z]
                elif (re.match("\w*",titulo)) ==None:
                    raise forms.ValidationError("Deben de ser caracters alfanumerico")
                return titulo

    def clean_cant_participante(self):
                cant_participante=self.cleaned_data.get('cant_participante')
                if cant_participante<0:
                    raise forms.ValidationError("Debe asignar un valor mayor que cero")
                return cant_participante

    def clean_fecha_creacion(self):
                fecha_creacion = self.cleaned_data.get('fecha_creacion')
                return fecha_creacion

    def clean_contPart(self):
                contPart=self.cleaned_data.get('contPart')
                if contPart!=0:
                    raise forms.ValidationError("Debe asignar como valor 0")
                return contPart
