# -*- coding: utf-8 -*-
# Generated by Django 1.9 on 2017-06-23 01:21
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Encuesta',
            fields=[
                ('id_encuesta', models.AutoField(editable=False, primary_key=True, serialize=False)),
                ('titulo', models.CharField(max_length=50)),
                ('cant_participante', models.IntegerField(blank=True)),
                ('fecha_creacion', models.DateField()),
                ('estado', models.BooleanField()),
            ],
            options={
                'ordering': ['id_encuesta'],
                'verbose_name_plural': 'Encuesta',
            },
        ),
        migrations.CreateModel(
            name='Pregunta',
            fields=[
                ('id_pregunta', models.AutoField(primary_key=True, serialize=False)),
                ('descripcion', models.CharField(max_length=100)),
                ('id_encuesta', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='SitioEncuesta.Encuesta')),
            ],
            options={
                'ordering': ['id_pregunta'],
                'verbose_name_plural': 'Preguntas',
            },
        ),
        migrations.CreateModel(
            name='Respuesta',
            fields=[
                ('id_respuesta', models.AutoField(primary_key=True, serialize=False)),
                ('contenido', models.CharField(max_length=100)),
                ('mejor_respuesta', models.BooleanField(default=False, verbose_name='Respuesta Favorita')),
                ('id_pregunta', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='SitioEncuesta.Pregunta')),
            ],
            options={
                'ordering': ['id_respuesta'],
                'verbose_name_plural': 'Respuestas',
            },
        ),
        migrations.CreateModel(
            name='Usuario',
            fields=[
                ('id_usuario', models.AutoField(max_length=10, primary_key=True, serialize=False)),
                ('ip_usuario', models.GenericIPAddressField(blank=True, default=None, null=True, protocol='IPv4', unique=True)),
                ('id_encuesta', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to='SitioEncuesta.Encuesta')),
            ],
            options={
                'ordering': ['id_usuario'],
                'verbose_name_plural': 'Usuarios',
            },
        ),
    ]
