from django.shortcuts import render
from django.core.urlresolvers import reverse,reverse_lazy
from django.views.generic import ListView, CreateView,UpdateView,DetailView,DeleteView
from SitioEncuesta.models import *
from SitioEncuesta.forms import *
from django.http import HttpResponse
from django.http import Http404
#######No para 1.9
#from django.urls import reverse
from django.shortcuts import get_object_or_404
from django.http import HttpResponseRedirect
from django.http import JsonResponse
from django.template import loader
from django.views import generic


# Create your views here.
def probando(request):
     return render(request,"p.html")

class ListPreguntaView(ListView):
     model = Pregunta
     template_name = "pregunta_list.html"

class DetailPregunta(DetailView):
    model = Pregunta
    template_name="detalle_pregunta.html"

class DeletePregunta(DeleteView):
    model = Pregunta
    template_name = 'eliminar_pregunta.html'

    def get_success_url(self):
        return reverse('pregunta_list')

class CreatePreguntaView(CreateView):
    model = Pregunta
    template_name = 'edit_pregunta.html'
    form_class=PreguntaForm

    def get_context_data(self, **kwargs):
        context=super(CreatePreguntaView,self).get_context_data(**kwargs)
        context['action']=reverse('pregunta_new')
        return context

    def get_success_url(self):
     return reverse_lazy('pregunta_list')

class UpdatePreguntaView(UpdateView):
    model=Pregunta
    template_name='edit_pregunta.html'
    form_class=PreguntaForm

    def get_context_data(self, **kwargs):
        context=super(UpdatePreguntaView,self).get_context_data(**kwargs)
        context['action']=reverse('pregunta_update',kwargs={'pk':self.get_object().id_pregunta})
        return context

    def get_success_url(self):
            return reverse('pregunta_list')

#VISTA DE RESPUESTAS

#VIEW DE RESPUESTA
class ListRespuestaView(ListView):
    model=  Respuesta
    template_name = "respuesta_list.html"

class DetailRespuesta(DetailView):
    model = Respuesta
    template_name = "detalle_respuesta.html"

class DeleteRespuesta(DeleteView):
    model = Respuesta
    template_name = 'eliminar_respuesta.html'
    def get_success_url(self):
        return reverse('respuesta_list')

class UpdateRespuestaView(UpdateView):
    model=Respuesta
    template_name='edit_respuesta.html'
    form_class=RespuestaForm

    def get_context_data(self, **kwargs):
        context=super(UpdateRespuestaView,self).get_context_data(**kwargs)
        context['action']=reverse('respuesta_update',kwargs={'pk':self.get_object().id_respuesta})
        return context

    def get_success_url(self):
            return reverse('respuesta_list')

class CreateRespuestaView(CreateView):
    model = Respuesta
    template_name = 'edit_respuesta.html'
    form_class= RespuestaForm

    def get_context_data(self, **kwargs):
        context=super(CreateRespuestaView,self).get_context_data(**kwargs)
        context['action']=reverse('respuesta_new')
        return context

    def get_success_url(self):
     return reverse_lazy('respuesta_list')

#VISTA DE ENCUESTA

class ListEncuestaView(ListView):
     model = Encuesta
     template_name = "encuesta_list.html"

class DetailEncuesta(DetailView):
    model = Encuesta
    template_name="detalle_encuesta.html"

class DeleteEncuesta(DeleteView):
    model = Encuesta
    template_name = 'eliminar_encuesta.html'
    def get_success_url(self):
        return reverse('encuesta_list')

class UpdateEncuestaView(UpdateView):
    model=Encuesta
    template_name='edit_encuesta.html'
    form_class=EncuestaForm

    def get_context_data(self, **kwargs):
        context=super(UpdateEncuestaView,self).get_context_data(**kwargs)
        context['action']=reverse('encuesta_update',kwargs={'pk':self.get_object().id_encuesta})
        return context

    def get_success_url(self):
            return reverse('encuesta_list')

class CreateEncuestaView(CreateView):
    model = Encuesta
    template_name = 'edit_encuesta.html'
    form_class= EncuestaForm

    def get_context_data(self, **kwargs):
        context=super(CreateEncuestaView,self).get_context_data(**kwargs)
        context['action']=reverse('encuesta_new')
        return context

    def get_success_url(self):
     return reverse_lazy('encuesta_list')

#################CAMBIOS

def responder(request, encuesta_id):
    if Encuesta.objects.get(id_encuesta=encuesta_id).cant_participante > Encuesta.objects.get(id_encuesta=encuesta_id).contPart:
        try:
            questions = Pregunta.objects.filter(id_encuesta=encuesta_id)
            encues= Encuesta.objects.get(id_encuesta=encuesta_id)
            context = {'question_list': questions , 'enc': encues}
        except Pregunta.DoesNotExist:
            raise Http404("Question does not exist")
        return render(request, 'encuestas/EEnProseso.html', context)
    else:
        return HttpResponseRedirect(reverse('fin'))

######PASO2
import json
import urllib
from django.contrib import messages
from django.conf import settings
	######################################## PARA CAPTCHA
	#Clave Secreta : 6Lc60CcUAAAAAO9IurnYNykjEP6f0isi9LmyL8no
	#Clave de Sitio: 6Lc60CcUAAAAAFKRkkK8Ip7TR6efPgzWhVS54bu3
	########################################

def votar(request, encuesta_id):##############Cambio
    encuesta = Encuesta.objects.get(id_encuesta = encuesta_id)
    ipso = Usuario.objects.filter(id_encuesta = encuesta)
    flag = 0
# Comenzar validacion reCAPTCHA
    recaptcha_response = request.POST.get('g-recaptcha-response')
    url = 'https://www.google.com/recaptcha/api/siteverify'
    values = {
        'secret': settings.GOOGLE_RECAPTCHA_SECRET_KEY,
        'response': recaptcha_response
    }
    data = urllib.parse.urlencode(values).encode()
    req =  urllib.request.Request(url, data=data)
    response = urllib.request.urlopen(req)
    result = json.loads(response.read().decode())
# finalizar validacion reCAPTCHA  
    if result['success']:
        for ipo in ipso:
            if ipo.ip_usuario == obtenerIp(request):
                flag=1 #para probar sin tener que ser rechazado por la ip, digite 0, normal 1
            else:
                pass
        if flag == 0:
            if encuesta.cant_participante > encuesta.contPart:###<- aQUI PONES VALIDACION DE NUMERO DE ENCUESTADOS
                preguntas = Pregunta.objects.filter(id_encuesta = encuesta_id)
                lista = []
                for pregunta in preguntas:
                    lista.append(pregunta.id_pregunta)
                respuestas = Respuesta.objects.filter(id_pregunta__in=lista)
                for pregunta in preguntas:
                    if pregunta.id_pregunta == 1:
                        listado = []
                        listado.append(int(request.POST.get('pp'+str(pregunta.id_pregunta))))
                    else:
                        listado = request.POST.getlist('pp'+str(pregunta.id_pregunta))
                    for elemento in listado:
                        respuesta = Respuesta.objects.get(id_respuesta = elemento)
                        respuesta.votes += 1
                        respuesta.save()
                encuesta.contPart += 1
                encuesta.save()
    ####
                iplist = Usuario.objects.filter(id_encuesta = Encuesta.objects.get(id_encuesta = encuesta_id))
                flag2 = 0
                for ipo in iplist:
                    if ipo.ip_usuario == obtenerIp(request):
                        flag=1
                    else:
                        pass
                if flag==0:
                    Usuario.objects.create(ip_usuario= obtenerIp(request), id_encuesta= Encuesta.objects.get(id_encuesta = encuesta_id))
                else:
                    pass
    ####
                return HttpResponseRedirect(reverse('resultados', args=(encuesta.id_encuesta,)))
                #return render(request, 'encuestas/EFResults.html', {'enc':encuesta, 'question_list': preguntas})
            else:
                return HttpResponseRedirect(reverse('fin'))
        else:
            return HttpResponseRedirect(reverse('resultados', args=(encuesta.id_encuesta,)))
    else:
        messages.error(request, 'Invalid reCAPTCHA. Please try again.')
        try:
            questions = Pregunta.objects.filter(id_encuesta=encuesta_id)
            encues= Encuesta.objects.get(id_encuesta=encuesta_id)
            context = {'question_list': questions , 'enc': encues}
        except Pregunta.DoesNotExist:
            raise Http404("Question does not exist")
        return render(request, 'encuestas/EEnProseso.html', context)



######PASO3###########################Cambio 1/7/17    
def resultados(request, encuesta_id):
#    iplist = Usuario.objects.filter(id_encuesta = Encuesta.objects.get(id_encuesta = encuesta_id))
#    flag = 0
#    for ipo in iplist:
#        if ipo.ip_usuario == obtenerIp(request):
#            flag=1
#        else:
#            pass
#    if flag==0:
#        Usuario.objects.create(ip_usuario= obtenerIp(request), id_encuesta= Encuesta.objects.get(id_encuesta = encuesta_id))
#    else:
#        pass
    try:
        questions = Pregunta.objects.filter(id_encuesta=encuesta_id)
        encues= Encuesta.objects.get(id_encuesta=encuesta_id)
        context = {'question_list': questions , 'enc': encues}
    except Pregunta.DoesNotExist:
        raise Http404("Question does not exist")
    return render(request, 'encuestas/EFResults.html', context)

######PASO4
def compartir(request,encuesta_id):
    encuesta = Encuesta.objects.get(id_encuesta = encuesta_id)
    context = {'enc': encuesta }
    return render(request, 'encuestas/Compartir.html', context)


def fin(request):
    return render(request, 'encuestas/fin.html')

def grafica(request, pregunta_id):
    questions = Pregunta.objects.get(id_pregunta=pregunta_id)
    return render(request, 'encuestas/chart.html', {"pre": questions})


###########################Prueba
############################### PARA CHARTS
from django.http import JsonResponse
from django.views.generic import View
#from rest_framework.views import APIView
#from rest_framework.response import Response



class HomeView(View):
    def get(self, request, *args, **kwargs):
        return render(request, 'encuestas/chart.html', {"customers": 20})


def get_data(request,pregunta_id):
    labels =[]
    adata =[]
    for elemento in Respuesta.objects.filter(id_pregunta = pregunta_id):
        labels.append(elemento.contenido)
        adata.append(elemento.votes)
    udata={
        "labels": labels,
        "default": adata,
    }
    return JsonResponse(udata)
#####################################
def obtenerIp(request):
    fowarded = request.META.get('HTTP_XFORWARDDED_FOR')
    ip = None
    if fowarded:
        ip = fowarded.split(',')[0]
    else:
        ip = request.META.get('REMOTE_ADDR')
    return ip

########################################
def muestreo(request, encuesta_id):
    encuesta = Encuesta.objects.get(id_encuesta = encuesta_id)
    context = {'enc': encuesta }
    return render(request, 'realizar_muestreo.html', context)

def Rmuestreo(request, encuesta_id):
    encuesta = Encuesta.objects.get(id_encuesta = encuesta_id)
    answer = request.POST['MargenE']
    if answer == '0.1':
        merr=0.1
    elif answer == '0.05':
        merr=0.05
    elif answer == '0.04':
        merr=0.04
    elif answer == '0.03':
        merr=0.03
    elif answer == '0.025':
        merr=0.025
    else:
    	merr=0.02
    answer2 = request.POST['NivelC']
    if answer2 == '2.57':
        nivc=2.57
    elif answer2 == '1.96':
        nivc=1.96
    else:
    	nivc=1.64

    inp= float(request.POST['tam'])
    
    tmuestra = (nivc**2.0)*((inp*0.5*0.5)/((merr**2.0)*(inp-1.0) + (nivc**2.0) *0.5*0.5))
    encuesta.cant_participante = int(tmuestra)
    encuesta.save()

    return HttpResponseRedirect(reverse('encuesta_update', args=(encuesta.id_encuesta,)))
